Subject: [AVT] SRTP with layered encoding

From: Marc Petit-Huguenin <[email-masked]>
Date: Mon, 19 Oct 2009 16:05:03 -0700

I was not able to find guidelines on how to use SRTP with multicast layered
encoding.  As all the layers share the same SSRC, the same master key cannot be
shared between them.

Using the same master key for all the layers would be great though, so I was
thinking that a way to do this would be to redefine the label byte so the 5
first bits are used for the layer number (from 0 to 31).

Any thoughts on this?  Should I write an I-D?

Thanks.

-- 
Marc Petit-Huguenin
Personal email: [email-masked]
Professional email: [email-masked]
Blog: http://blog.marc.petit-huguenin.org

---

From: "Jonathan Lennox" <[email-masked]>
Date: Tue, 20 Oct 2009 11:46:41 -0400

I think that using different master keys for different RTP sessions is
fairly essential for SRTP, to prevent two-time pad failures; I'd be
pretty concerned about breaking this.  Why do you want to?

-- 
Jonathan Lennox
Vidyo, Inc
[email-masked]

> -----Original Message-----
> From: Marc Petit-Huguenin [mailto:[email-masked]]
> Sent: Monday, October 19, 2009 7:05 PM
> To: [email-masked]
> Subject: [AVT] SRTP with layered encoding
> 
> _______________________________________________
> Audio/Video Transport Working Group
> [email-masked]
> https://www.ietf.org/mailman/listinfo/avt

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Tue, 20 Oct 2009 09:11:01 -0700

Hi Jonathan,

> pretty concerned about breaking this.  Why do you want to?

My proposal does not create two-time pad failures, as the layer number would be
integrated in the label used to derive the sessions keys.

This has the advantage to integrate nicely with EKT, as the EKT packets would be
sent only on the RTCP packets of the base layer.

---

From: "Jonathan Lennox" <[email-masked]>
Date: Tue, 20 Oct 2009 12:20:28 -0400

What I guess I don't see is why layered encoding should be treated any
differently than "ordinary" multimedia, e.g. separate audio and video
sessions.

-- 
Jonathan Lennox
Vidyo, Inc
[email-masked]

> Sent: Tuesday, October 20, 2009 12:11 PM
> To: Jonathan Lennox
> Cc: [email-masked]
> Subject: Re: [AVT] SRTP with layered encoding
> 
> Hi Jonathan,
> 
> Jonathan Lennox wrote:
> This has the advantage to integrate nicely with EKT, as the EKT
packets
> would be

---

From: "Jonathan Lennox" <[email-masked]>
Date: Tue, 20 Oct 2009 12:28:55 -0400

(Following up to myself.)

Which is to say, if you want to have some way to optimize EKT for the
multiple RTP session case, that's great; but I don't see any reason why
any mechanism shouldn't work equally well for multimedia as for layered
encodings.

-- 
Jonathan Lennox
Vidyo, Inc
[email-masked]

> From: Jonathan Lennox [mailto:[email-masked]]
> Sent: Tuesday, October 20, 2009 12:20 PM
> To: Marc Petit-Huguenin
> Cc: [email-masked]
> > > I think that using different master keys for different RTP
sessions
> > is
> > My proposal does not create two-time pad failures, as the layer
> number
> > would be

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Tue, 20 Oct 2009 09:35:54 -0700

> differently than "ordinary" multimedia, e.g. separate audio and video

They share the same SSRC, so they are treated as a whole (i.e. BYE and non-CNAME
SDES only on base layer).  I thought that it made sense to also apply SRTP (and
EKT) to this sessions as a whole.

---

From: "Jonathan Lennox" <[email-masked]>
Date: Tue, 20 Oct 2009 12:56:36 -0400

Ah, I see, yes.

It still feels somewhat like a layer violation to me (the SRTP stack
needs to know that it's processing a layered encoding), but I see why
it's different than multimedia.

I think this would make sense only for EKT-type keying mechanisms, i.e.
where session keys are bound to SSRCs, not for SDesc or DTLS/SRTP where
a single session key applies across all SSRCs of an RTP session.  Yes?
In the latter case, the fact that SSRCs are shared doesn't make any
difference.

-- 
Jonathan Lennox
Vidyo, Inc
[email-masked]

> Sent: Tuesday, October 20, 2009 12:36 PM
> To: Jonathan Lennox
> Cc: [email-masked]

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Tue, 20 Oct 2009 10:08:19 -0700

> In the latter case, the fact that SSRCs are shared doesn't make any

Yes, my first idea was that it was specific to EKT (I sent an email to the
authors few weeks ago) but then I thought that it was perhaps an SRTP issue.
I'll wait to see what the EKT authors have to say about this.

Thanks!

---

From: Colin Perkins <[email-masked]>
Date: Tue, 20 Oct 2009 20:25:54 +0100

On 20 Oct 2009, at 17:35, Marc Petit-Huguenin wrote:
> Jonathan Lennox wrote:
>> What I guess I don't see is why layered encoding should be treated  
>> any differently than "ordinary" multimedia, e.g. separate audio and  
>> video sessions.
>
> They share the same SSRC, so they are treated as a whole (i.e. BYE  
> and non-CNAME SDES only on base layer).  I thought that it made  
> sense to also apply SRTP (and EKT) to this sessions as a whole.

As I've said before, I'm unconvinced that using a common SSRC across  
multiple layers is a good idea. It seems to cause a lot of special  
cases for little benefit.

-- 
Colin Perkins
http://csperkins.org/

---

From: Colin Perkins <[email-masked]>
Date: Tue, 20 Oct 2009 21:06:41 +0100

Sure - I'm all for deprecating that.

Colin

On 20 Oct 2009, at 20:45, Marc Petit-Huguenin wrote:
> Probably, but isn't this what RFC 3550 section 8.3 says?
>
> Colin Perkins <[email-masked]> wrote:
>

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Wed, 21 Oct 2009 09:54:46 -0700

> Sure - I'm all for deprecating that.

OK.  How do you suggest to proceed?  draft-ietf-avt-rapid-rtp-sync could be a
good place for this, but I am willing to write an I-D if needed.

Thanks.